# LSB Test Execution Framework
# Tcl test module
#
# Copyright (C) 2006 Free Standards Group. All rights reserved.
#
# This program has been developed by ISP RAS for FSG with some parts
# derived from lsb-autotest written by Jiri Dluhos <jdluhos@suse.cz>
# Copyright (C) 2005-2006 SuSE Linux Products GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

package Tcl_test;
use strict;

use Common;
use Packages;
use Journal;

require Tests::Test_common;
@Tcl_test::ISA = qw(Test_common);

=head ##
Class Tcl_test Inherits Test_common;
=cut ##

sub new {
  my $self  = Test_common->new();
  $self->{NAME} = "tcl";
  $self->{FILES} .= " tcl8.4.11-tests.tar";
  $self->{PACKAGES} .= " lsb-tcl";
  $self->{SOURCES} .= " appbat test_data";
  $self->{BETA_SOURCES} .= " appbat";
  bless($self);
  return $self;
}

sub run {
    my $self = shift;
    
    unless (-d "/tmp/lsb-packages") { cmd("mkdir -p /tmp/lsb-packages") };
    cmd ("ln -s -f \"$package_dir/app-battery/tests/tcl8.4.11-tests.tar\";"
         ."mv -f \"$package_dir/tcl8.4.11-tests.tar\" /tmp/lsb-packages" );
    
    Test_common::run($self);
}

sub journal {
    my $self = shift;
    
    # Copy the results to the output directory.
#    cmd ("cp /tmp/lsb-tcl-test.out $results_dir/test_journals/tcl.tcljournal");
    
    # Parse the journal.
    parse_tcl_journal("Tcl Test", "tcl",
        "$results_dir/test_journals/tcl.tcljournal", $self);
}

1; # return value