/*-------------------------------------------------------------------------*/
/* LSB Autotest, the automatic LSB test running tool                       */
/*                                                                         */
/* Copyright (c) 2006 SUSE LINUX Products GmbH                             */
/*                                                                         */
/* Author: Jiri Dluhos <jdluhos@suse.cz>                                   */
/*                                                                         */
/* This program is free software; you can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License version 2 as       */
/* published by the Free Software Foundation.                              */
/*                                                                         */
/* This program is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/* GNU General Public License for more details.                            */
/*                                                                         */
/* You should have received a copy of the GNU General Public License       */
/* along with this program; if not, write to the Free Software             */
/* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,              */
/* MA 02110-1301, USA.                                                     */
/*-------------------------------------------------------------------------*/

#ifndef HOST_INFO_H
#define HOST_INFO_H

/*-------------------------------------------------------------------------*/

/* Information about the host machine. */
extern char * hostname;
extern char * host_os_name;
extern char * host_os_release;
extern char * host_os_version;
extern char * host_platform;
extern char * host_distro_name;
extern char * host_distro_release;
extern char * host_machine_triplet;

/*-------------------------------------------------------------------------*/

/*
 * Reads information about the host computer.
 */
void read_host_info();

/*
 * Prints the discovered host information on the standard output.
 */
void print_host_info();

/*-------------------------------------------------------------------------*/

#endif
