/*-------------------------------------------------------------------------*/
/* LSB Autotest, the automatic LSB test running tool                       */
/*                                                                         */
/* Copyright (c) 2006 SUSE LINUX Products GmbH                             */
/*                                                                         */
/* Author: Jiri Dluhos <jdluhos@suse.cz>                                   */
/*                                                                         */
/* This program is free software; you can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License version 2 as       */
/* published by the Free Software Foundation.                              */
/*                                                                         */
/* This program is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/* GNU General Public License for more details.                            */
/*                                                                         */
/* You should have received a copy of the GNU General Public License       */
/* along with this program; if not, write to the Free Software             */
/* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,              */
/* MA 02110-1301, USA.                                                     */
/*-------------------------------------------------------------------------*/

#ifndef LSB_AUTOTEST_H
#define LSB_AUTOTEST_H

#include <time.h>
#include <unistd.h>
#include <sys/types.h>

/*-------------------------------------------------------------------------*/

/* The package directory (specified by the '--package-dir' option). */
extern char * package_dir;

/* The output file (specified by the '--output' option). */
extern char * output_file;

/* The temporary directory for storing the test journals before they are
 * collected into a single output archive. Can be specified by the '--output'
 * option, otherwise defaults to '/tmp/lsb-autotest-result'.
 */
extern char * output_dir;

/* True if downloads are enabled (the '--download' option). */
extern int download_enabled;

/* True to keep existing packages (the '--keep-packages' option). */
extern int keep_packages;

/* True to load beta packages (the '--beta' option). */
extern int try_beta_packages;

/* The e-mail address of the tester (specified by the '--mailto' option),
 * or NULL if not set.
 */
extern char * tester_email;

/* The time when the autotest run has started. */
extern struct tm startup_time;

/* The directory where the autotest executable is installed. */
extern char * our_dir;

/* True to print test output */
extern int verbose;

/* True if not to check wheter packages are installed */
extern int trust_packages;

/* The PID of the main process, which is responsible for final cleanup. */
extern pid_t main_process_pid;

/*-------------------------------------------------------------------------*/

#endif
