/*-------------------------------------------------------------------------*/
/* LSB Autotest, the automatic LSB test running tool                       */
/*                                                                         */
/* Copyright (c) 2006 SUSE LINUX Products GmbH                             */
/*                                                                         */
/* Author: Jiri Dluhos <jdluhos@suse.cz>                                   */
/*                                                                         */
/* This program is free software; you can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License version 2 as       */
/* published by the Free Software Foundation.                              */
/*                                                                         */
/* This program is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/* GNU General Public License for more details.                            */
/*                                                                         */
/* You should have received a copy of the GNU General Public License       */
/* along with this program; if not, write to the Free Software             */
/* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,              */
/* MA 02110-1301, USA.                                                     */
/*-------------------------------------------------------------------------*/

#ifndef TET_JOURNAL_COMPAT_H
#define TET_JOURNAL_COMPAT_H

#include "tet_journal.h"

/*-------------------------------------------------------------------------*/

/**
 * Loads a journal from a Tcl or Expect test and converts it
 * to a TET journal.
 */
TetJournal * tcl_to_tet_journal(const char * filename);

/**
 * Loads a journal from a Python test and converts it
 * to a TET journal.
 */
TetJournal * python_to_tet_journal(const char * filename);

/**
 * Attempts to identify a journal and load it as a TET journal.
 * Returns NULL on failure.
 */
TetJournal * load_any_journal(const char * filename);

/*-------------------------------------------------------------------------*/

#endif
