/*-------------------------------------------------------------------------*/
/* LSB Autotest, the automatic LSB test running tool                       */
/*                                                                         */
/* Copyright (c) 2006 SUSE LINUX Products GmbH                             */
/*                                                                         */
/* Author: Jiri Dluhos <jdluhos@suse.cz>                                   */
/*                                                                         */
/* This program is free software; you can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License version 2 as       */
/* published by the Free Software Foundation.                              */
/*                                                                         */
/* This program is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/* GNU General Public License for more details.                            */
/*                                                                         */
/* You should have received a copy of the GNU General Public License       */
/* along with this program; if not, write to the Free Software             */
/* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,              */
/* MA 02110-1301, USA.                                                     */
/*-------------------------------------------------------------------------*/

#include "time_utils.h"
#include "string_utils.h"
#include <assert.h>

/*-------------------------------------------------------------------------*/

void get_current_time(struct tm * time_structure)
{
    time_t now;

    assert(time_structure);

    /* Get the current time. */
    now = time(NULL);

    /* Convert it to the time structure. */
    localtime_r(&now, time_structure);
}

/*-------------------------------------------------------------------------*/

char * format_time_for_filename(const struct tm * time_structure)
{
    return format_malloc(
        "%04d-%02d-%02d-%02dh-%02dm",
        time_structure->tm_year + 1900,
        time_structure->tm_mon + 1,
        time_structure->tm_mday,
        time_structure->tm_hour,
        time_structure->tm_min
    );
}

/*-------------------------------------------------------------------------*/
