/*-------------------------------------------------------------------------*/
/* LSB Autotest, the automatic LSB test running tool                       */
/*                                                                         */
/* Copyright (c) 2006 SUSE LINUX Products GmbH                             */
/*                                                                         */
/* Author: Jiri Dluhos <jdluhos@suse.cz>                                   */
/*                                                                         */
/* This program is free software; you can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License version 2 as       */
/* published by the Free Software Foundation.                              */
/*                                                                         */
/* This program is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/* GNU General Public License for more details.                            */
/*                                                                         */
/* You should have received a copy of the GNU General Public License       */
/* along with this program; if not, write to the Free Software             */
/* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,              */
/* MA 02110-1301, USA.                                                     */
/*-------------------------------------------------------------------------*/

#ifndef USER_UTILS_H
#define USER_UTILS_H

/*-------------------------------------------------------------------------*/

/*
 * Returns true if the user exists, false otherwise.
 */
int user_exists(const char * user_name);

/*
 * Returns the user ID corresponding to the given user name.
 */
int get_user_id(const char * user_name);

/*
 * Returns the home directory of the user (as a string allocated
 * via malloc()).
 */
char * get_user_home_dir(const char * user_name);

/*
 * Returns the primary group ID belonging to the given user name.
 */
int get_user_primary_group_id(const char * user_name);

/*
 * Returns the group ID corresponding to the given group name.
 */
int get_group_id(const char * group_name);

/*
 * Adds a new user. Has no effect if the user already exists.
 */
void add_user(const char * user_name);

/*-------------------------------------------------------------------------*/

#endif
