#!/bin/sh

ps -A | grep '\bserver.pl\b' >/dev/null 2>&1 
if (( !$? ))
then
	echo "    Server is already running."
	exit 1
fi

port=$1
[ -z "$port" ] && port="8888"

cd `dirname $0`/../webui
./server.pl 8888 >./server.log.$port 2>&1 &
echo "    Server started. Log file location:"
echo "    "`pwd`"/server.log.$port"

# Try to open start page in a browser
echo ""
echo "    Start page should be opened in a browser in a short time."
echo "    If it won't, you could find web-UI at http://`uname -n`:$port"
browser_found=0

for br_name in "opera" "/usr/bin/mozilla-firefox" "firefox" "konqueror" "epiphany" "galeon" "mozilla"
do
	if which $br_name >/dev/null 2>&1 
	then
		`which $br_name` "http://localhost:$port" >/dev/null 2>&1 &
		browser_found=1
		break
	fi
done

if  (( !$browser_found ))
then
	echo "    Couldn't find any web-browser."
	echo "    Go to 'http://localhost:$port' to configure and launch tests."
fi
