#!/usr/bin/perl -w

# LSB Test Execution Framework
# FTP Refresh List Module (tests_conf_refresh.pl)
#
# Copyright (C) 2006 Free Standards Group. All rights reserved.
#
# This program has been developed by ISP RAS for FSG.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

my $old_handle = select (STDOUT);
$| = 1;
select ($old_handle);

my $DOCUMENT_ROOT = $0;
$DOCUMENT_ROOT =~ s/\/[^\/]+$//;

eval(`cat $DOCUMENT_ROOT/Templates.pl`);

# Just to suppress the warning about possible typo in CONFIG...
%CONFIG = () unless defined(%CONFIG);

print "HTTP/1.0 200 OK\n";
print "Content-type: text/html\n\n";

print_header("Updating Progress", "conf");

print <<DATA;
<h1>Retrieving data</h1>
<p><font color="green"><b>Please, wait while updating the data from FTP...</b></font><span id="refresh_status"></span><br />
Time elapsed: <span id="timer" style="font-family: monospace; color: blue;">00:00</span></p><br />
<div style="width: 300px; height: 12px; border: 1px solid #004000;"><img src="images/progress.png" alt="progress: 0/0" width="0" height="12" id="progress_bar" style="display: none;" /></div>
<script language="javascript" type="text/javascript">
// <![CDATA[
var elapsed_time = 0;
var finished = 0;
function update_timer() {
	++elapsed_time;
	var elem = document.getElementById("timer");
	if (elem && !finished) {
		var m = Math.floor(elapsed_time / 60);
		var s = elapsed_time - m * 60;
		var tmp = "";
		tmp += (m < 10) ? "0" + m : m;
		tmp += ":";
		tmp += (s < 10) ? "0" + s : s;
		elem.innerHTML = tmp;
		setTimeout("update_timer()", 1000);
	}
}

function set_progress(done, total) {
	var elem = document.getElementById("progress_bar");
	if (elem) {
		elem.style.display = ((done == 0) ? 'none' : '');
		elem.alt = "progress: " + done + "/" + total;
		if (done > total)
			done = total;
		elem.width = Math.round(done * 300 / total);
	}
}

setTimeout("update_timer()", 1000);
// ]]>
</script>
DATA

print_footer(1);     # do not finish with </body></html> now!

my $failure = 0;
if (open(FILE, $CONFIG{"TESTS_DIR"}."/lsb-tef.pl -v0 --list-refresh-only -D |"))
{
	while (<FILE>) {
		if (m/^#PROGRESS:\s*(\d+)\/(\d+)\s*$/) {
			my ($done, $total) = ($1, $2);
			print "<script language=\"javascript\" type=\"text/javascript\">\n// <![CDATA[\nset_progress($done, $total);\n// ]]>\n</script>\n";
		}
	}
	close(FILE);
}
else {
	$failure = 1;
}

if ($failure) {
	my $error_txt;
	if ($failure == 1) {
		$error_text = "Error: Could not start the refresh script! ($!)";
	}
	else {
		$error_text = "Error: (code: $failure)!";
	}
	print <<DATA;
<script language="javascript" type="text/javascript">
// <![CDATA[
	finished = 1;
	var elem = document.getElementById("refresh_status");
	if (elem)
		elem.innerHTML = " <font color=\\"red\\"><b>$error_text</b></font><br /><a href=\\"javascript:history.go(-1);\\">Back to previous page</a><br />";
// ]]>
</script>
DATA
}
else {
	my $new_url = ($_POST{"certify"} ? "tests_cert.pl" : "tests_conf.pl");
	if ($_GET{"profile"}) {
		$new_url .= "?profile=".$_GET{"profile"};
	}
	print "<script language=\"javascript\" type=\"text/javascript\">\n// <![CDATA[\nfinished = 1;\nlocation.replace(\"$new_url\");\n// ]]>\n</script>\n";
}

print "</body>\n</html>\n";
